task BQSR {
	String sample
	String SENTIEON_INSTALL_DIR
	String fasta

	File dbsnp_dir
	String dbsnp
	File dbmills_dir
	String db_mills
	File Split_bam
	File Split_bam_index
	File ref_dir
	String docker
	String cluster_config
	String disk_size

	
	command <<<
		set -o pipefail
		set -e
		export SENTIEON_LICENSE=192.168.0.55:8990
		nt=$(nproc)

		${SENTIEON_INSTALL_DIR}/bin/sentieon driver --traverse_param 1000000/10000 -r ${ref_dir}/${fasta} -t $nt -i ${Split_bam} --algo QualCal -k ${dbsnp_dir}/${dbsnp} -k ${dbmills_dir}/${db_mills} ${sample}_recal_data.table

		${SENTIEON_INSTALL_DIR}/bin/sentieon driver --traverse_param 1000000/10000 -r ${ref_dir}/${fasta} -t $nt -i ${Split_bam} -q ${sample}_recal_data.table --algo QualCal -k ${dbsnp_dir}/${dbsnp} -k ${dbmills_dir}/${db_mills} ${sample}_recal_data.table.post --algo ReadWriter ${sample}.sorted.deduped.recaled.bam

		${SENTIEON_INSTALL_DIR}/bin/sentieon driver --traverse_param 1000000/10000 -t $nt --algo QualCal --plot --before ${sample}_recal_data.table --after ${sample}_recal_data.table.post ${sample}_recal_data.csv

		${SENTIEON_INSTALL_DIR}/bin/sentieon plot QualCal -o ${sample}_bqsrreport.pdf ${sample}_recal_data.csv

	>>>
	runtime {
	dockerTag:docker
    cluster: cluster_config
    systemDisk: "cloud_ssd 40"
    dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/"	
	}

	output {
		File recal_table = "${sample}_recal_data.table"
		File recal_post = "${sample}_recal_data.table.post"
		File recaled_bam = "${sample}.sorted.deduped.recaled.bam"
		File recaled_bam_index = "${sample}.sorted.deduped.recaled.bam.bai"
		File recal_csv = "${sample}_recal_data.csv"
		File bqsrreport_pdf = "${sample}_bqsrreport.pdf"
	}
}
